import * as i0 from '@angular/core';
import { Directive, Input, HostListener, NgModule } from '@angular/core';
import * as i1 from '@angular/animations';

class BassCarouselDirective {
    constructor() { }
    ngAfterViewInit() {
        this.initCarousol();
    }
    initCarousol() {
        const nextBtn = document.querySelector('.' + this.carousalPreviousClass);
        nextBtn.hidden = true;
        const carouselContain = document.querySelector('.' + this.carousalContainerClass);
        const carouselContainUl = document.querySelector('.' + this.carousalULClass);
        if (carouselContain && carouselContainUl) {
            const carouselContainWidth = carouselContain.clientWidth;
            const carouselWidth = carouselContainUl.scrollWidth;
            if (carouselWidth > carouselContainWidth) {
                const nextBtn = document.querySelector('.' + this.carousalNextClass);
                nextBtn.hidden = false;
            }
        }
        else {
            if (!carouselContain) {
                console.log('No! container class not found.');
            }
            if (!carouselContainUl) {
                console.log('No! ui class not found.');
            }
        }
    }
}
BassCarouselDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
BassCarouselDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.3", type: BassCarouselDirective, selector: "[bassCarouselInit]", inputs: { carousalContainerClass: "carousalContainerClass", carousalULClass: "carousalULClass", carousalNextClass: "carousalNextClass", carousalPreviousClass: "carousalPreviousClass" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bassCarouselInit]'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { carousalContainerClass: [{
                type: Input
            }], carousalULClass: [{
                type: Input
            }], carousalNextClass: [{
                type: Input
            }], carousalPreviousClass: [{
                type: Input
            }] } });

class BassCarouselNextDirective {
    constructor(builder) {
        this.builder = builder;
    }
    click() {
        const nextBtn = document.querySelector('.' + this.carousalPreviousClass);
        nextBtn.hidden = false;
        const carouselContain = document.querySelector('.' + this.carousalULClass);
        if (carouselContain) {
            const leftPos = carouselContain.scrollLeft;
            if (leftPos !== 0) {
                this.showHideCarouselBtns(leftPos);
            }
            carouselContain.scrollTo({ left: (leftPos + this.pxPerClick), behavior: 'smooth' });
        }
        else {
            console.log('No! ui class not found.');
        }
    }
    showHideCarouselBtns(leftPos) {
        const carouselContain = document.querySelector('.' + this.carousalContainerClass);
        const carouselContainUl = document.querySelector('.' + this.carousalULClass);
        if (carouselContain && carouselContainUl) {
            const carouselContainWidth = carouselContain.clientWidth;
            const carouselWidth = carouselContainUl.scrollWidth;
            if (carouselContainWidth + leftPos + this.pxPerClick >= carouselWidth) {
                const nextBtn = document.querySelector('.' + this.carousalNextClass);
                nextBtn.hidden = true;
            }
            if (carouselContainWidth + leftPos === carouselContainWidth) {
                const nextBtn = document.querySelector('.' + this.carousalPreviousClass);
                nextBtn.hidden = true;
            }
        }
        else {
            if (!carouselContain) {
                console.log('No! container class not found.');
            }
            if (!carouselContainUl) {
                console.log('No! ui class not found.');
            }
        }
    }
}
BassCarouselNextDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselNextDirective, deps: [{ token: i1.AnimationBuilder }], target: i0.ɵɵFactoryTarget.Directive });
BassCarouselNextDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.3", type: BassCarouselNextDirective, selector: "[bassCarouselNext]", inputs: { carousalContainerClass: "carousalContainerClass", carousalULClass: "carousalULClass", carousalNextClass: "carousalNextClass", carousalPreviousClass: "carousalPreviousClass", pxPerClick: "pxPerClick" }, host: { listeners: { "click": "click($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselNextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bassCarouselNext]'
                }]
        }], ctorParameters: function () { return [{ type: i1.AnimationBuilder }]; }, propDecorators: { carousalContainerClass: [{
                type: Input
            }], carousalULClass: [{
                type: Input
            }], carousalNextClass: [{
                type: Input
            }], carousalPreviousClass: [{
                type: Input
            }], pxPerClick: [{
                type: Input
            }], click: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BassCarouselPreviousDirective {
    constructor() { }
    click() {
        const nextBtn = document.querySelector('.' + this.carousalNextClass);
        nextBtn.hidden = false;
        const carouselContain = document.querySelector('.' + this.carousalULClass);
        if (carouselContain) {
            const leftPos = carouselContain.scrollLeft;
            this.showHideCarouselBtns(leftPos);
            carouselContain.scrollTo({ left: (leftPos - this.pxPerClick), behavior: 'smooth' });
        }
        else {
            console.log('No! ui class not found.');
        }
    }
    showHideCarouselBtns(leftPos) {
        const carouselContain = document.querySelector('.' + this.carousalContainerClass);
        const carouselContainUl = document.querySelector('.' + this.carousalULClass);
        if (carouselContain && carouselContainUl) {
            const carouselContainWidth = carouselContain.clientWidth;
            const carouselWidth = carouselContainUl.scrollWidth;
            if ((carouselContainWidth - leftPos) + this.pxPerClick >= carouselWidth) {
                const nextBtn = document.querySelector('.' + this.carousalNextClass);
                nextBtn.hidden = true;
            }
            if ((carouselContainWidth - leftPos) + this.pxPerClick >= carouselContainWidth) {
                const nextBtn = document.querySelector('.' + this.carousalPreviousClass);
                nextBtn.hidden = true;
            }
        }
        else {
            if (!carouselContain) {
                console.log('No! container class not found.');
            }
            if (!carouselContainUl) {
                console.log('No! ui class not found.');
            }
        }
    }
}
BassCarouselPreviousDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselPreviousDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
BassCarouselPreviousDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.3", type: BassCarouselPreviousDirective, selector: "[bassCarouselPrevious]", inputs: { carousalContainerClass: "carousalContainerClass", carousalULClass: "carousalULClass", carousalNextClass: "carousalNextClass", carousalPreviousClass: "carousalPreviousClass", pxPerClick: "pxPerClick" }, host: { listeners: { "click": "click($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselPreviousDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bassCarouselPrevious]'
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { carousalContainerClass: [{
                type: Input
            }], carousalULClass: [{
                type: Input
            }], carousalNextClass: [{
                type: Input
            }], carousalPreviousClass: [{
                type: Input
            }], pxPerClick: [{
                type: Input
            }], click: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BassCarouselReInItDirective {
    constructor(builder) {
        this.builder = builder;
    }
    click() {
        setTimeout(() => {
            this.initCarousol();
        }, 500);
    }
    initCarousol() {
        const carouselContain = document.querySelector('.' + this.carousalContainerClass);
        const carouselContainUl = document.querySelector('.' + this.carousalULClass);
        if (carouselContain && carouselContainUl) {
            const carouselContainWidth = carouselContain.clientWidth;
            const carouselWidth = carouselContainUl.scrollWidth;
            if (carouselWidth > carouselContainWidth) {
                const nextBtn = document.querySelector('.z2CarouselBtnNext_' + this.z2CarousalKey);
                nextBtn.hidden = false;
            }
        }
        else {
            if (!carouselContain) {
                console.log('No! container class not found.');
            }
            if (!carouselContainUl) {
                console.log('No! ui class not found.');
            }
        }
    }
}
BassCarouselReInItDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselReInItDirective, deps: [{ token: i1.AnimationBuilder }], target: i0.ɵɵFactoryTarget.Directive });
BassCarouselReInItDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.3", type: BassCarouselReInItDirective, selector: "[bassCarouselReInIt]", inputs: { carousalContainerClass: "carousalContainerClass", carousalULClass: "carousalULClass", carousalNextClass: "carousalNextClass", carousalPreviousClass: "carousalPreviousClass", z2CarousalKey: "z2CarousalKey" }, host: { listeners: { "click": "click($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: BassCarouselReInItDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[bassCarouselReInIt]'
                }]
        }], ctorParameters: function () { return [{ type: i1.AnimationBuilder }]; }, propDecorators: { carousalContainerClass: [{
                type: Input
            }], carousalULClass: [{
                type: Input
            }], carousalNextClass: [{
                type: Input
            }], carousalPreviousClass: [{
                type: Input
            }], z2CarousalKey: [{
                type: Input
            }], click: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class NgCarouselModule {
}
NgCarouselModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: NgCarouselModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgCarouselModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: NgCarouselModule, declarations: [BassCarouselReInItDirective,
        BassCarouselDirective,
        BassCarouselNextDirective,
        BassCarouselPreviousDirective], exports: [BassCarouselReInItDirective,
        BassCarouselDirective,
        BassCarouselNextDirective,
        BassCarouselPreviousDirective] });
NgCarouselModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: NgCarouselModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.3", ngImport: i0, type: NgCarouselModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BassCarouselReInItDirective,
                        BassCarouselDirective,
                        BassCarouselNextDirective,
                        BassCarouselPreviousDirective
                    ],
                    imports: [],
                    exports: [
                        BassCarouselReInItDirective,
                        BassCarouselDirective,
                        BassCarouselNextDirective,
                        BassCarouselPreviousDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of angular-custom-carousel
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BassCarouselDirective, BassCarouselNextDirective, BassCarouselPreviousDirective, BassCarouselReInItDirective, NgCarouselModule };
//# sourceMappingURL=angular-custom-carousel.mjs.map
